<?

//------------------------------------------------------------------------------
//UPNP_Browse_Functions.ips.php / Browse024 - function--------------------------
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//function ContentDirectory_Browse----------------------------------------------
//------------------------------------------------------------------------------
//IN:   $ObjectID
//IN:   $BrowseFlag
//IN:   $Filter
//IN:   $StartingIndex
//IN:   $RequestedCount
//IN:   $SortCriteria
//------------------------------------------------------------------------------
//OUT:  $Result
//OUT:  $NumberReturned
//OUT:  $TotalMatches
//OUT:  $TotalMatches
//------------------------------------------------------------------------------

function ContentDirectory_Browse ($addressServ, $portServ, $ObjectID, $BrowseFlag, $Filter, $StartingIndex, $RequestedCount, $SortCriteria)
{
$header='POST /TMSContentDirectory/Control HTTP/1.1
HOST: '.$addressServ.':'.$portServ.'
SOAPACTION: "urn:schemas-upnp-org:service:ContentDirectory:1#Browse"
CONTENT-TYPE: text/xml; charset="utf-8"
connection: close';

$xml='<?xml version="1.0" encoding="utf-8"?>
<s:Envelope s:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:s="http://schemas.xmlsoap.org/soap/envelope/">
   <s:Body>
      <u:Browse xmlns:u="urn:schemas-upnp-org:service:ContentDirectory:1">
         <ObjectID>'.$ObjectID.'</ObjectID>
         <BrowseFlag>'.$BrowseFlag.'</BrowseFlag>
         <Filter>'.$Filter.'</Filter>
         <StartingIndex>'.$StartingIndex.'</StartingIndex>
         <RequestedCount>'.$RequestedCount.'</RequestedCount>
         <SortCriteria>'.$SortCriteria.'</SortCriteria>
      </u:Browse>
   </s:Body>
</s:Envelope>';

$content_ContentDirectory_Browse = $header . '
Content-Length: '. strlen($xml) .'

'. $xml;

$fp = fsockopen ($addressServ, $portServ, $errno, $errstr, 10);

fputs ($fp, $content_ContentDirectory_Browse);

		$buffer = stream_get_contents($fp, -1);

		echo $buffer;

		$vars = explode("\r\n\r\n", $buffer); 						//Header abtrennen
		$header = $vars[0];                    					//Header
		$message = $vars[1];                   					//Message

		$handle = fopen('ContentDirectory_Browse.xml', "w"); 	//XML schreiben
		fwrite($handle, $message);
		fclose($handle);

fclose($fp);

//XML cutten und Variablen schreiben--------------------------------------------

		$vars1 = explode("<Result>", $message);
		$cutted1 = $vars1[0];
		$cutted2 = $vars1[1];
		$vars2 = explode("</Result>", $cutted2);
      $cutted3 = $vars2[1];
		$Result = $vars2[0];

		echo $Result;

	SetValue(42199, $Result);

		$vars1 = explode("<NumberReturned>", $message);
      $cutted1 = $vars1[0];
		$cutted2 = $vars1[1];
		$vars2 = explode("</NumberReturned>", $cutted2);
		$cutted3 = $vars2[1];
		$NumberReturned = $vars2[0];

		echo $NumberReturned;

	SetValue(26946, $NumberReturned);

		$vars1 = explode("<TotalMatches>", $message);
		$cutted1 = $vars1[0];
		$cutted2 = $vars1[1];
		$vars2 = explode("</TotalMatches>", $cutted2);
		$cutted3 = $vars2[1];
		$TotalMatches = $vars2[0];

		echo $TotalMatches;

	SetValue(52875, $TotalMatches);

		$vars1 = explode("<UpdateID>", $message);
      $cutted1 = $vars1[0];
		$cutted2 = $vars1[1];
		$vars2 = explode("</UpdateID>", $cutted2);
      $cutted3 = $vars2[1];
		$UpdateID = $vars2[0];

		echo $UpdateID;

	SetValue(53319, $UpdateID);

Return ($Result);
}

//------------------------------------------------------------------------------
//function BrowseList($Result) --> $Results in Arrays ausgeben------------------
//------------------------------------------------------------------------------
//Sortierung:-------------------------------------------------------------------
//------------------------------------------------------------------------------
//01: container/item
//02: id
//03: refID
//04: parentid
//05: restricted
//06: artist
//07: album
//08: title
//09: resource
//10: duration
//11: size
//12: bitrate
//13: albumArtURI
//14: genre
//15: date
//16: originalTrackNumber
//17: class
//18: extension
//------------------------------------------------------------------------------

function BrowseList($Result)
{
$xmlParser = xml_parser_create();
$Result = substr($Result, stripos($Result, '&lt;'));
$Result = substr($Result, 0, strrpos($Result, '&gt;') + 4);
$Result = str_replace(array("&lt;", "&gt;", "&quot;", "&amp;", "%3a", "%2f", "%25"), array("<", ">", "\"", "&", ":", "/", "%"), $Result);

$xml = new SimpleXMLElement($Result);
$liste = array();

for($i=0,$size=count($xml);$i<$size;$i++)
	{
	if(isset($xml->container[$i])){
		//Wenn Container vorhanden, dann ist es ein Browse Element
		//Wenn Item vorhanden, dann ist es ein Song
		$aktrow = $xml->container[$i];
   		$attr = $xml->container[$i]->attributes();
      		$liste[$i]['typ'] = "container";

	}else if(isset($xml->item[$i])){
		//Item vorhanden also nur noch Musik
      		$aktrow = $xml->item[$i];
      		$attr = $xml->item[$i]->attributes();
      		$liste[$i]['typ'] = "item";

	}else{
		//Fehler aufgetreten
   	return;
	}

$id = $attr['id'];
$refid = $attr['refID'];
$parentid = $attr['parentID'];
$restricted = $attr['restricted'];
$albumart = $aktrow->xpath("upnp:albumArtURI");
$titel = $aktrow->xpath("dc:title");
$interpret = $aktrow->xpath("dc:creator");
$date = $aktrow->xpath("dc:date");
$album = $aktrow->xpath("upnp:album");
$genre = $aktrow->xpath("upnp:genre");
$originalTrackNumber = $aktrow->xpath("upnp:originalTrackNumber");
$class = $aktrow->xpath("upnp:class");
$extension = $aktrow->xpath("pv:extension");

	if(isset($id) && !empty($id)){
			$liste[$i]['id']=(string)$id;
		}else{
			$liste[$i]['id']="";
		}
	if(isset($refid) && !empty($refid)){
			$liste[$i]['refid']=(string)$refid;
		}else{
			$liste[$i]['refid']="";
		}
	if(isset($parentid) && !empty($parentid)){
			$liste[$i]['parentid']=(string)$parentid;
		}else{
			$liste[$i]['parentid']="";
		}
	if(isset($restricted) && !empty($restricted)){
			$liste[$i]['restricted']=(string)$restricted;
		}else{
			$liste[$i]['restricted']="";
		}
	if(isset($interpret[0])){
			$liste[$i]['artist']=(string)$interpret[0];
		}else{
			$liste[$i]['artist']="";
		}
	if(isset($album[0])){
			$liste[$i]['album']=(string)$album[0];
		}else{
			$liste[$i]['album']="";
		}
$liste[$i]['title']=(string)$titel[0]; //immer vorhanden

	if(isset($aktrow->res)){
	   		$res = (string)$aktrow->res;
	   		$liste[$i]['resource'] = $res;
		}else{
	   		$liste[$i]['resource'] = "";
	 	}
	$resattr = $aktrow->res->attributes();
	//wenn name res und attribute duration vorhanden
	if(isset($aktrow->res) and isset($resattr['duration'])){
			$liste[$i]['duration']=(string)$resattr['duration'];
		}else{
			$liste[$i]['duration']="";
		}
	//wenn name res und attribute size vorhanden
	if(isset($aktrow->res) and isset($resattr['size'])){
			$liste[$i]['size']=(string)$resattr['size'];
		}else{
			$liste[$i]['size']="";
		}
	//wenn name res und attribute bitrate vorhanden
	if(isset($aktrow->res) and isset($resattr['bitrate'])){
			$liste[$i]['bitrate']=(string)$resattr['bitrate'];
		}else{
			$liste[$i]['bitrate']="";
		}
	if(isset($albumart[0])){
			$liste[$i]['albumArtURI']=(string)$albumart[0];
		}else{
			$liste[$i]['albumArtURI'] ="";
		}
	if(isset($genre[0])){
			$liste[$i]['genre']=(string)$genre[0];
		}else{
			$liste[$i]['genre']="";
		}
	if(isset($date[0])){
			$liste[$i]['date']=(string)$date[0];
		}else{
			$liste[$i]['date']="";
		}
	if(isset($originalTrackNumber[0])){
			$liste[$i]['originalTrackNumber']=(string) $originalTrackNumber[0];
		}else{
			$liste[$i]['originalTrackNumber']="";
		}
	if(isset($class[0])){
			$liste[$i]['class']=(string)$class[0];
		}else{
			$liste[$i]['class']="";
		}
	if(isset($extension[0])){
			$liste[$i]['extension']=(string)$extension[0];
		}else{
			$liste[$i]['extension']="";
		}
}
return ($liste);
}

?>